int latchPin = 31;
int clockPin = 32;
int dataPin = 30;

// 행 데이터로 선택된 LED만 1의 값을 가짐
byte row_data[] = {
  0b00111100, 0b01000010,
  0b10010101, 0b10100001,
  0b10100001, 0b10010101,
  0b01000010, 0b00111100
};

// 열 데이터로 선택된 열만 1로 표시되어 있음. 실제로는 반전하여 출력
byte col_data[8] = {
  0x01, 0x02, 0x04, 0x08,
  0x10, 0x20, 0x40, 0x80
};

void setup() {
  pinMode(latchPin, OUTPUT); // 각 제어 핀을 출력으로 설정
  pinMode(dataPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
}

void loop() {
  for (int i = 0; i < 8; i++) {
    digitalWrite(latchPin, LOW); // 래치 출력 금지
    // 열 데이터 → 행 데이터 순으로 출력
    shiftOut(dataPin, clockPin, MSBFIRST, ~col_data[i]); // 반전 출력
    shiftOut(dataPin, clockPin, MSBFIRST, row_data[i]);
    digitalWrite(latchPin, HIGH); // 래치 출력 허용
  }
}
